/*
Innovation Third
Default Code

Originally By:  Steven Li c.2004
Modified By: Sandra Escandor 2010

 */

#include <p18f2550.h>  //PIC
#include <pwm.h> //Pulse Width Modulation
#include <adc.h> //Analogue Digital Conversion
#include <delays.h> //Time Delay
#include <stdlib.h> //Standard Library
#include <timers.h>
#include <math.h> //Math Library
#include <usart.h> //HyperTerminal
//#include <xlcd.h>
#include <stddef.h>
#include <string.h>
#include <portb.h>
//-Ou- -Ot- -Ob- -Op- -Or- -Od- -Opa- -S

//*******************************Define Functions***************************


void rx_handler(void);


//void DelayFor18TCY (void);
//void DelayPORXLCD (void);
//void DelayXLCD (void);



void ftoa (char *buf, double fval, int cField, int cPlaces);



//*******************************Define Constants***************************
#define ISC_FOSC 40000000
#define OUTPUT 0
#define INPUT 1
#define FALSE 0
#define TRUE 1
#define PI 3.141592654

//*******************************Define Aliases*****************************

//PORTA INPUT/OUTPUT
#define ISC_RA0_IO TRISAbits.TRISA0
#define ISC_RA1_IO TRISAbits.TRISA1
#define ISC_RA2_IO TRISAbits.TRISA2
#define ISC_RA3_IO TRISAbits.TRISA3
#define ISC_RA4_IO TRISAbits.TRISA4  //Runtime Indicator
#define ISC_RA5_IO TRISAbits.TRISA5
#define ISC_RA6_IO TRISAbits.TRISA6

//PORTA OUTPUT
#define ISC_RA0_OUT LATAbits.LATA0
#define ISC_RA1_OUT LATAbits.LATA1
#define ISC_RA2_OUT LATAbits.LATA2
#define ISC_RA3_OUT LATAbits.LATA3
#define ISC_RA4_OUT LATAbits.LATA4
#define ISC_RA5_OUT LATAbits.LATA5
#define ISC_RA6_OUT LATAbits.LATA6

//PORTA INPUT
#define ISC_RA0_IN PORTAbits.RA0
#define ISC_RA1_IN PORTAbits.RA1
#define ISC_RA2_IN PORTAbits.RA2
#define ISC_RA3_IN PORTAbits.RA3
#define ISC_RA4_IN PORTAbits.RA4  //Runtime Indicator
#define ISC_RA5_IN PORTAbits.RA5
#define ISC_RA6_IN PORTAbits.RA6

//PORTB INPUT/OUTPUT
#define ISC_RB0_IO TRISBbits.TRISB0
#define ISC_RB1_IO TRISBbits.TRISB1
#define ISC_RB2_IO TRISBbits.TRISB2
#define ISC_RB3_IO TRISBbits.TRISB3
#define ISC_RB4_IO TRISBbits.TRISB4
#define ISC_RB5_IO TRISBbits.TRISB5
#define ISC_RB6_IO TRISBbits.TRISB6
#define ISC_RB7_IO TRISBbits.TRISB7

//PORTB OUTPUT
#define ISC_RB0_OUT LATBbits.LATB0
#define ISC_RB1_OUT LATBbits.LATB1
#define ISC_RB2_OUT LATBbits.LATB2
#define ISC_RB3_OUT LATBbits.LATB3
#define ISC_RB4_OUT LATBbits.LATB4
#define ISC_RB5_OUT LATBbits.LATB5
#define ISC_RB6_OUT LATBbits.LATB6
#define ISC_RB7_OUT LATBbits.LATB7

//PORTB INPUT
#define ISC_RB0_IN PORTBbits.RB0
#define ISC_RB1_IN PORTBbits.RB1
#define ISC_RB2_IN PORTBbits.RB2
#define ISC_RB3_IN PORTBbits.RB3
#define ISC_RB4_IN PORTBbits.RB4
#define ISC_RB5_IN PORTBbits.RB5
#define ISC_RB6_IN PORTBbits.RB6
#define ISC_RB7_IN PORTBbits.RB7

//PORTC INPUT/OUTPUT
#define ISC_RC0_IO TRISCbits.TRISC0
#define ISC_RC1_IO TRISCbits.TRISC1
#define ISC_RC2_IO TRISCbits.TRISC2
#define ISC_RC3_IO TRISCbits.TRISC3
#define ISC_RC4_IO TRISCbits.TRISC4
#define ISC_RC5_IO TRISCbits.TRISC5
#define ISC_RC6_IO TRISCbits.TRISC6
#define ISC_RC7_IO TRISCbits.TRISC7

//PORTC OUTPUT
#define ISC_RC0_OUT LATCbits.LATC0
#define ISC_RC1_OUT LATCbits.LATC1
#define ISC_RC2_OUT LATCbits.LATC2
#define ISC_RC3_OUT LATCbits.LATC3
#define ISC_RC4_OUT LATCbits.LATC4
#define ISC_RC5_OUT LATCbits.LATC5
#define ISC_RC6_OUT LATCbits.LATC6
#define ISC_RC7_OUT LATCbits.LATC7

//PORTC INPUT
#define ISC_RC0_IN PORTCbits.RC0
#define ISC_RC1_IN PORTCbits.RC1
#define ISC_RC2_IN PORTCbits.RC2
#define ISC_RC3_IN PORTCbits.RC3
#define ISC_RC4_IN PORTCbits.RC4
#define ISC_RC5_IN PORTCbits.RC5
#define ISC_RC6_IN PORTCbits.RC6
#define ISC_RC7_IN PORTCbits.RC7

//PORTD INPUT/OUTPUT
#define ISC_RD0_IO TRISDbits.TRISD0
#define ISC_RD1_IO TRISDbits.TRISD1
#define ISC_RD2_IO TRISDbits.TRISD2
#define ISC_RD3_IO TRISDbits.TRISD3
#define ISC_RD4_IO TRISDbits.TRISD4
#define ISC_RD5_IO TRISDbits.TRISD5
#define ISC_RD6_IO TRISDbits.TRISD6
#define ISC_RD7_IO TRISDbits.TRISD7

//PORTD OUTPUT
#define ISC_RD0_OUT LATDbits.LATD0
#define ISC_RD1_OUT LATDbits.LATD1
#define ISC_RD2_OUT LATDbits.LATD2
#define ISC_RD3_OUT LATDbits.LATD3
#define ISC_RD4_OUT LATDbits.LATD4
#define ISC_RD5_OUT LATDbits.LATD5
#define ISC_RD6_OUT LATDbits.LATD6
#define ISC_RD7_OUT LATDbits.LATD7

//PORTD INPUT
#define ISC_RD0_IN PORTDbits.RD0
#define ISC_RD1_IN PORTDbits.RD1
#define ISC_RD2_IN PORTDbits.RD2
#define ISC_RD3_IN PORTDbits.RD3
#define ISC_RD4_IN PORTDbits.RD4
#define ISC_RD5_IN PORTDbits.RD5
#define ISC_RD6_IN PORTDbits.RD6
#define ISC_RD7_IN PORTDbits.RD7

//PORTE INPUT/OUTPUT
#define ISC_RE0_IO TRISEbits.TRISE0
#define ISC_RE1_IO TRISEbits.TRISE1
#define ISC_RE2_IO TRISEbits.TRISE2

//PORTE OUTPUT
#define ISC_RE0_OUT LATEbits.LATE0
#define ISC_RE1_OUT LATEbits.LATE1
#define ISC_RE2_OUT LATEbits.LATE2

//PORTE INPUT
#define ISC_RE0_IN PORTEbits.RE0
#define ISC_RE1_IN PORTEbits.RE1
#define ISC_RE2_IN PORTEbits.RE2


/* Set configuration bits for use with ICD2 / PICDEM2 PLUS Demo Board:
 *  - set HS oscillator
 *  - disable watchdog timer
 *  - disable low voltage programming
 */
#pragma config FOSC = HS
#pragma config WDT = OFF
#pragma config LVP = OFF
#pragma config XINST = ON
#pragma config DEBUG = OFF 

#pragma config PBADEN = OFF //Disable PortB A/D Converter


//********************************Define Global Variables*********************************

//                char           -128 to 127  (8 Bits)
//         signed char           -128 to 127
//       unsigned char              0 to 255

//                 int        -32,768 to 32,767  (16 Bits)
//        unsigned int              0 to 65,535
//               short        -32,768 to 32,767
//      unsigned short              0 to 65,535

//          short long     -8,388,608 to 8,388,607  (24 Bits)
// unsigned short long              0 to 16,777,215

//                long -2,147,483,648 to 2,147,483,647  (32 Bits)
//       unsigned long              0 to 4,294,967,295

//               float 1.17549435e-38 to 6.80564693e+38
//              double 1.17549435e-38 to 6.08564693e+38

unsigned char isc_runtimeindicator = 0;

//Place User Defined Global Variables Here
unsigned char USARTcharacter=0;
unsigned char USARTflag=0;

unsigned char ultrasonicbusy_flag = 0;

char LCD_String[];

int channel_1 = 11;
int channel_2 = 22;
int channel_3 = 33;
int channel_4 = 44;

long distance = 125.6;
//int left_wheel_speed=60;
//int right_wheel_speed=60;
//int left_wheel_pwm=0;
//int right_wheel_pwm=0;
//long left_wheel_speed_sensor=0;
//long right_wheel_speed_sensor=0;

//A/D Conversion
unsigned int ISC_AN0_IN = 0;
unsigned int ISC_AN1_IN = 0;
unsigned int ISC_AN2_IN = 0;
unsigned int ISC_AN3_IN = 0;
unsigned int ISC_AN4_IN = 0;
unsigned int ISC_AN5_IN = 0;
unsigned int ISC_AN6_IN = 0;
unsigned int ISC_AN7_IN = 0;

//********************************************Interrupt Handler*****************************************
#pragma interrupt rx_handler
void rx_handler (void)
{
	while ((INTCONbits.INT0IF == 1) || (INTCONbits.TMR0IF == 1) || (INTCON3bits.INT1IF == 1) || (INTCON3bits.INT2IF == 1))
	{
		if (INTCONbits.INT0IF == 1)//Caused By PORTB Interrupt0
		{
			CloseTimer3();
			//distance = (double) ReadTimer3();

			ultrasonicbusy_flag = 0;
			INTCONbits.INT0IF = 0;
		}

		if (INTCON3bits.INT1IF == 1)//Caused By PORTB Interrupt1
		{
			INTCON3bits.INT1IF = 0;
		}

		if (INTCON3bits.INT2IF == 1)//Caused By PORTB Interrupt2
		{
			INTCON3bits.INT2IF = 0;
		}

		if(INTCONbits.TMR0IF == 1)
		{
			ISC_RB0_OUT = !ISC_RB0_OUT;
			WriteTimer0(15651); //This value was determined so that the timer register would get cleared/set at a 200 Hz rate

        //Note: IF we need to use a -2.5 to 2.5 voltage range for our input into the ADC, we need to have the
        //      +VRef switched onto the +Vref Pin in OpenADC. Then, we need to connect the 2.5 voltage source to 
        //      the EXTERNAL +VRef pin of micro. We also need to have the -VRef switched onto the -VRef pin in OpenADC. Then,
        //      we need to connect the -2.5 voltage source to the EXTERNAL -VRef pin of the micro.
        //      Note: When I say EXTERNAL, it means +Vref is not Vdd, and -Vref is not ground.
		OpenADC(ADC_FOSC_RC & ADC_RIGHT_JUST & ADC_0_TAD, ADC_CH0 & ADC_INT_OFF & ADC_VREFPLUS_EXT & ADC_VREFMINUS_EXT, 15);
		Delay10TCYx(5);
		ConvertADC();
		while(BusyADC());
		ISC_AN0_IN = ReadADC();

		//AN1
		OpenADC(ADC_FOSC_RC & ADC_RIGHT_JUST & ADC_0_TAD, ADC_CH1 & ADC_INT_OFF & ADC_VREFPLUS_EXT & ADC_VREFMINUS_EXT, 15);
		Delay10TCYx(5);
		ConvertADC();
		while(BusyADC());
		ISC_AN1_IN = ReadADC();

		//AN2
		OpenADC(ADC_FOSC_RC & ADC_RIGHT_JUST & ADC_0_TAD, ADC_CH2 & ADC_INT_OFF & ADC_VREFPLUS_EXT & ADC_VREFMINUS_EXT, 15);
		Delay10TCYx(5);
		ConvertADC();
		while(BusyADC());
		ISC_AN2_IN = ReadADC();
            
            //Note: LCD_String is ASCII representation of the float number we get from the AD converter
           
			//Channel 1
			ftoa(&LCD_String,(float)ISC_AN0_IN,5,0);
			putsUSART ((char)LCD_String);
			putrsUSART ((const far rom char *)",");
			//Channel 2
			ftoa(&LCD_String,(float)ISC_AN1_IN,5,0);
			putsUSART ((char)LCD_String);
			putrsUSART ((const far rom char *)",");
			//Channel 3
			ftoa(&LCD_String,(float)ISC_AN2_IN,5,0);
			putsUSART ((char)LCD_String);
			putrsUSART ((const far rom char *)",");
			
			putrsUSART ((const far rom char *)"\r\n");

			INTCONbits.TMR0IF = 0;
		}


		else //Interrupt NOT Caused By Timer0)
		{
			USARTflag = 1;
			USARTcharacter=getcUSART();
			putrsUSART ((const far rom char *)"");//Note:  Appaears To Require A Delay To Function.  This is a work-around
			putcUSART (USARTcharacter);
		}
	}


}



////////////////////////////////////////////////////////////////////////////////////////////////////

void main (void)
{
    //**************************Define Input/Output****************************************
    //PORTA
	ISC_RA0_IO = INPUT;  //AN0
	ISC_RA1_IO = INPUT;  //AN1
	ISC_RA2_IO = INPUT;  //AN2
	ISC_RA3_IO = INPUT;  //AN3
	ISC_RA4_IO = OUTPUT;  //Runtime Indicator
	ISC_RA5_IO = INPUT;  //AN4
	ISC_RA6_IO = INPUT;

    //PORTB
	ISC_RB0_IO = OUTPUT;
	ISC_RB1_IO = OUTPUT;
	ISC_RB2_IO = OUTPUT;
	ISC_RB3_IO = OUTPUT;
	ISC_RB4_IO = OUTPUT;
	ISC_RB5_IO = OUTPUT;
	ISC_RB6_IO = OUTPUT; //ICD2
	ISC_RB7_IO = OUTPUT; //ICD2

	//PORTC
	ISC_RC0_IO = OUTPUT;
	ISC_RC1_IO = OUTPUT; //PWM2
	ISC_RC2_IO = OUTPUT; //PWM1
//	ISC_RC3_IO = OUTPUT;
//	ISC_RC4_IO = OUTPUT;
//	ISC_RC5_IO = OUTPUT;
	ISC_RC6_IO = OUTPUT; //USART Output
	ISC_RC7_IO = INPUT;  //USART Input

//	//PORTD
//	ISC_RD0_IO = OUTPUT;
//	ISC_RD1_IO = OUTPUT;
//	ISC_RD2_IO = OUTPUT;
//	ISC_RD3_IO = OUTPUT;
//	ISC_RD4_IO = OUTPUT;
//	ISC_RD5_IO = OUTPUT;
//	ISC_RD6_IO = OUTPUT;
//	ISC_RD7_IO = OUTPUT;
//
//	//PORTE
//	ISC_RE0_IO = INPUT;  //AN5
//	ISC_RE1_IO = INPUT;  //AN6
//	ISC_RE2_IO = INPUT;  //AN7

    //**************************Set Initial Values*****************************************
    //PORTA
	ISC_RA0_OUT = FALSE;  //AN0
	ISC_RA1_OUT = FALSE;  //AN1
	ISC_RA2_OUT = FALSE;  //AN2
	ISC_RA3_OUT = FALSE;  //AN3
	ISC_RA4_OUT = FALSE;  //Runtime Indicator
	ISC_RA5_OUT = FALSE;  //AN4
	ISC_RA6_OUT = FALSE;

    //PORTB
	ISC_RB0_OUT = FALSE;
	ISC_RB1_OUT = FALSE;
	ISC_RB2_OUT = FALSE;
	ISC_RB3_OUT = FALSE;
	ISC_RB4_OUT = FALSE;
	ISC_RB5_OUT = FALSE;
	ISC_RB6_OUT = FALSE;
	ISC_RB7_OUT = FALSE;

    //PORTC
	ISC_RC0_OUT = FALSE;
	ISC_RC1_OUT = FALSE;
	ISC_RC2_OUT = FALSE;
//	ISC_RC3_OUT = FALSE;
//	ISC_RC4_OUT = FALSE;
//	ISC_RC5_OUT = FALSE;
	ISC_RC6_OUT = FALSE;
	ISC_RC7_OUT = FALSE;


	OpenUSART(USART_TX_INT_OFF & USART_RX_INT_ON & USART_ASYNCH_MODE & USART_EIGHT_BIT & USART_CONT_RX & USART_BRGH_HIGH, (21));  //115200
	//USART Interrupts
	RCONbits.IPEN=1;
	IPR1bits.RCIP=1;
	INTCONbits.GIEH=1;
    putrsUSART ((const far rom char *)"\rProgram Started. Original By Steven Li, 2004. Modified By Sandra Escandor, 2010.  Firmware Version 1.0\r\n");

	//*****************************Program Initialization**************************
	OpenTimer0(TIMER_INT_ON & T0_16BIT & T0_SOURCE_INT & T0_PS_1_1);
	while (1)
    {



	}
}
		

//From:http://forum.microchip.com/tm.aspx?m=69532&mpage=1&key=&#70460
/******************************************************************************
*	Function Name	: ftoa(fbuf,fval, cField,cPlace)
*	Input		: fval - float argument
*			; cField - total number of characters in result (including ".")
*			: cPlace - number of digit after decimal point  
*	Output		: buf - ASCII representation of the float number "fval"
*								:        
*	Return		: 
*	Description	: Convert float to ASCII
*
	//This routine correctly formats a floating point number into it's ASCII representation.
	//The routine will insert leading spaces as necessary to satisfy the requirements of the
	//specified formatting.
	//
	//eg:
	//ftoa(buf,12.34567,5,3);		//Ask for 5 digit field including '.',  and 3 digits after.
	//After the routine, buf will contain: '12.34'.
	//
	//This allows for easier integration of displays onto the VFD.
	//
*example usage: 
* char buf[];
* ftoa(buf,1.2345,10,3);
*
* buf will contain '     1.234' 
******************************************************************************/
void ftoa (char *buf, double fval, int cField, int cPlaces)
{
	long lTemp;
	long scale;
	int i;
	char dbuf[8];			// Temporary - used and overwritten in routine
	char pbuf[8];			// Temporary - used and overwritten in routine
	char fbuf[16];			// The output string is built here
														//  and copied into the *buf buffer at the end.
	char cDigits;
	//---------------------------------------------------------------------------
	size_t szTemp;
	if (cPlaces)
	{
	  cDigits = (cField - cPlaces - 1);	//FP formatting.  Includes '.' and decimal part
	}
	else
	{
	  cDigits = cField;		//Special case for integers
	}
																			//EXAMPLE USED: fval=123.456789, fp(5,5) has been set
	memset (fbuf, 0, sizeof (fbuf));		//Clear the buffer
	scale = 1;													//Set default scale value
	lTemp = (long) fval;			//convert double to long	- ltemp=123
	ltoa (lTemp, dbuf);			//convert long to ascii in dbuf
	szTemp = strlen (dbuf);		//How many digits does the number use?
																			//---------------------------------------	
	if ((char) szTemp < cDigits)		//Do we need leading whitespaces?
	{
		for (i=0; i < (cDigits - (int) szTemp +0); i++)
		{
		 pbuf[i] = ' ';		//Insert the reqd number of spaces into the buffer 'pbuf'
		}
		if ((fval < 0) && (fval > -1) )      //Special case for -0.1 (etc) where 'digit' is = 0, but fval is -ve.
		{
		 pbuf[i-1] = '-';		//Add -ve symbol to the main buffer
		}
		pbuf[i] = 0;											                                                               //Null terminate the spaces so strcat can find it
																			//No need to add '1' - the for loop does this for us!
		strcat(fbuf, pbuf);		//Add the spaces (and sign?) into the main buffer
	}
	else
	{
		if ((fval < 0) && (fval > -1) )  	//Special case for -0.1 (etc) where 'digit' is = 0, but fval is -ve.
		{
			fbuf[0] = '-';	//Add -ve symbol to the main buffer
			fbuf[1] = 0;	//Null terminate
		}
	}
	strcat(fbuf, dbuf);			//Add the numerical part to the main buffer (after '-' and spaces if reqd)
	if (cPlaces)				//Do we need the decimal part?
	{															
		strcatpgm2ram (fbuf, ".");	//add '.' to end of main buffer
		switch (cPlaces)		// Convert fractional	
		{
			case 1:	scale = 10; break;
			case 2:	scale = 100; break;
			case 3:     scale = 1000;  break;
			case 4:	scale = 10000; break;
			case 5:     scale = 100000; break;
		}
		fval = (fval - (int) fval);               //Remove integer part... fval=0.456789

		if (fval >= 0)		// Do not lose "0" in fractional part (i.e. 0.0456)
			fval += 1;
		else
			fval -= 1;
									
		fval *= scale;
		
		if (fval >= 0)										
		 fval += 0.5f;		//  For positive round number up
		else
		 fval -= 0.5f;		// For negative round number down
										
		lTemp = (long) fval;		//convert to long integer - ltemp=45678
		if (lTemp < 0) lTemp =- lTemp;	//No negative fractions!!! (prevents -1.-234 etc)
		ltoa (lTemp, dbuf);		//copy into dbuf - dbuf='45678'
		strcat(fbuf, &dbuf[1]);		//add the fractional part to the main buffer
	}				// without "1" in dbuf[0]
	strncpy (buf, fbuf, (size_t) cField);	//copy the final result to the output buffer
	buf[cField] = 0;			//Null terminate buf
									
}	
/*****************************************************************************/


